reset;
model;

var u01 >= 0;
var u02 >= 0;
var u11u >= 0;
var u11d >= 0;
var u12u >= 0;
var u12d >= 0;
var u21uu >= 0;
var u21ud >= 0;
var u21du >= 0;
var u21dd >= 0;
var u22uu >= 0;
var u22ud >= 0;
var u22du >= 0;
var u22dd >= 0;

###################
var u31uuu >= 0;
var u31uud >= 0;
var u31udu >= 0;
var u31udd >= 0;
var u31duu >= 0;
var u31dud >= 0;
var u31ddu >= 0;
var u31ddd >= 0;
var u32uuu >= 0;
var u32uud >= 0;
var u32udu >= 0;
var u32udd >= 0;
var u32duu >= 0;
var u32dud >= 0;
var u32ddu >= 0;
var u32ddd >= 0;
###################

param G := 80000;
param q := 4;

maximize obj: 0.125*(-q*u31uuu + u32uuu) + 0.125*(-q*u31uud + u32uud) + 0.125*(-q*u31udu + u32udu) + 0.125*(-q*u31udd + u32udd)
            + 0.125*(-q*u31duu + u32duu) + 0.125*(-q*u31dud + u32dud) + 0.125*(-q*u31ddu + u32ddu) + 0.125*(-q*u31ddd + u32ddd);

s.t. vS0: u01 + u02 <= 55000;

s.t. vS1u:1.25*u01 + 1.14*u02 >= u11u + u12u;
s.t. vS1d:1.06*u01 + 1.12*u02 >= u11d + u12d;

s.t. vS2uu:1.25*u11u + 1.14*u12u >= u21uu + u22uu;
s.t. vS2ud:1.06*u11u + 1.12*u12u >= u21ud + u22ud;
s.t. vS2du:1.25*u11d + 1.14*u12d >= u21du + u22du;
s.t. vS2dd:1.06*u11d + 1.12*u12d >= u21dd + u22dd;

s.t. vs3uuu:1.25*u21uu + 1.14*u22uu + u31uuu - u32uuu >= G;
s.t. vs3uud:1.06*u21uu + 1.12*u22uu + u31uud - u32uud >= G;
s.t. vs3udu:1.25*u21ud + 1.14*u22ud + u31udu - u32udu >= G;
s.t. vs3udd:1.06*u21ud + 1.12*u22ud + u31udd - u32udd >= G;
s.t. vs3duu:1.25*u21du + 1.14*u22du + u31duu - u32duu >= G;
s.t. vs3dud:1.06*u21du + 1.12*u22du + u31dud - u32dud >= G;
s.t. vs3ddu:1.25*u21dd + 1.14*u22dd + u31ddu - u32ddu >= G;
s.t. vs3ddd:1.06*u21dd + 1.12*u22dd + u31ddd - u32ddd >= G;


option solver cplex;
solve;
display u01,u02;

display u11u,u11d,u12u,u12d;

display u21uu,u21ud,u22uu,u22ud,u21du,u21dd,u22du,u22dd;

display u31uuu,u31uud,u32uuu,u32uud,u31udu,u31udd,u32udu,u32udd,u31duu,u31dud,u32duu,u32dud,u31ddu,u31ddd,u32ddu,u32ddd;









